program test3;
(*$I CONVERT.INC*)
(*$I INPUT2.INC*)
(*$I BOX.INC*)
(*$I FORM2.INC*)

var
  element: FormElementPtr;
  s: WorkString;

(* Initializes the form elements. This procedure is called from InitForm. *)
procedure InitFormElements;
begin
  case formIdx of
    1: begin
          AddField(FTText, 20, 'Name', 10, 6, 17, 6, false);
          
          NewAndLinkWithPrevElement;
          AddField(FTInteger, 5, 'Int', 10, 8, 17, 8, true);
        
          NewAndLinkWithPrevElement;
          AddField(FTNumNatural, 3, 'Gr|~e in cm', 10, 10, 24, 10, false);
        
          NewAndLinkWithPrevElement;
          AddField(FTReal, 10, 'Real', 10, 12, 24, 12, false);
        
          NewAndLinkWithPrevElement;
          AddField(FTDate, 10, 'Geburtsdatum', 10, 14, 24, 14, false);
        
          NewAndLinkWithPrevElement;
          AddField(FTFileName, 14, 'Dateiname', 10, 16, 24, 16, false);
        
          NewAndLinkWithPrevElement;
          AddButton(Ok, 1, 18, 15, 'OK');
        
          NewAndLinkWithPrevElement;
          AddButton(Cancel, 20, 18, 15, 'Abbrechen');
        end;
     2: begin
          AddField(FTDate, 10, 'Datum', 15, 6, 25, 6, false);
        
          NewAndLinkWithPrevElement;
          AddButton(Ok, 15, 9, 15, 'OK');
        
          NewAndLinkWithPrevElement;
          AddButton(Cancel, 33, 9, 15, 'Abbrechen');
        end;
   end; (* case *)
end; (* InitFormElements *)


(* Writes the current field's text and moves to the next element. *)
procedure NextField;
begin
  WriteCharPtrString(element^.field^.txt);
  element := element^.next;
  WriteLn;
end; (* NextField *)


(* Writes the current button's activation status and moves to the next element. *)
procedure NextButton;
begin
  if element^.button^.activated then WriteLn('yes') else WriteLn('no');
  element := element^.next;
end; (* NextButton *)


(* Displays a headline. *)
procedure Headline;
begin
  ClrScr;
  WriteLn('FORM2-Test');
  WriteLn; WriteLn;
end; (* Headline *)

begin
  SetDecimalChar(',');
  SetMessageLine(31);

  Headline;
  Write('*** Form 1 ***');
  
  Mark(form_HeapTop);
  InitForm(1);
  s := 'Vorbelegung';
  SetFieldText(1, s);
  ProcessForm;

  GotoXY(1, 22);
  element := form_FirstElement;
  Write('Name        : '); NextField;
  Write('Int         : '); NextField;
  Write('Gr|~e       : '); NextField;
  Write('Real        : '); NextField;
  Write('Geburtsdatum: '); NextField;
  Write('Dateiname   : '); NextField;
  Write('OK          : '); NextButton;
  Write('Abbrechen   : '); NextButton;
  if FormCancelled then
    WriteLn('Cancelled')
  else
    WriteLn('Confirmed');

  Release(form_HeapTop);
  WaitForKey;

  Headline;
  Write('*** Form 2 ***');
  
  Mark(form_HeapTop);
  InitForm(2);
  ProcessForm;

  GotoXY(1, 22);
  element := form_FirstElement;
  Write('Datum       : '); NextField;
  Write('OK          : '); NextButton;
  Write('Abbrechen   : '); NextButton;
  if FormCancelled then
    WriteLn('Cancelled')
  else
    WriteLn('Confirmed');

  Release(form_HeapTop);
  WaitForKey;
end.
